;This is an example script provided with the installation of BricsCAD V22.
;
;This script is provided AS IS without warranty of any kind. Author(s) disclaim all
;implied warranties including, without limitation, any implied warranties of
;merchantability or of fitness for a particular purpose. The entire risk arising out of
;the use or performance of the sample script and documentation remains with you. In no
;event shall author(s) be held liable for any damages whatsoever (including, without
;limitation, damages for loss of business profits, business interruption, loss of business
;information, or other pecuniary loss) arising out of the use of or inability to use the
;script or documentation. The script is not guaranteed to work with future or previous
;versions of BricsCAD except the one it is installed with. The presensce of the script in
;future versions is not guaranteed and is a subject to change within any future update to
;BricsCAD.


;This script generates a name and write it to the corresponding bim property
;The name is constructed as follows:
;first 2 characters of the bimtype, ".", the story of the bim entity, ".", the sequence number
(vl-load-bim)

(defun C:AutoName (/ ent number story bimtype name)
  (if (setq ss (ssget '((-4 . "<NOT") (0 . "SECTIONOBJECT") (-4 . "NOT>"))))  ; selectionset except sections
    (repeat (setq i (sslength ss))
      (setq ent (ssname ss (setq i (1- i))))
      (setq number (bim:get-property ent "SequenceNumber"))
      (if (= nummer nil) (setq nummer ""))
      (setq story (bim:get-assigned-story ent))
      (if (= story nil) (setq story ""))
      (setq bimtype (bim:get-bimtype ent))
      (if (= bimtype nil) (setq bimtype ""))
      (setq name (strcat (substr bimtype 1 2) "." story "." number))
      (bim:set-property ent "Name" name)
    )
  )
  (princ)
)

(C:AutoName)
(princ)
